#ifndef __tftp_h
#define __tftp_h

#define OPCODE_LEN 2
#define BLOCK_LEN 2
#define FNAME_LEN 256 // including '\0'
#define MODE_LEN 9 // including '\0'
#define DATA_LEN 512
#define ERRCODE_LEN 2
#define ERRMSG_LEN 256 // including '\0'

#define OP_RRQ 0x01
#define OP_WRQ 0x02
#define OP_DATA 0x03
#define OP_ACK 0x04
#define OP_ERROR 0x05

#define ERR_CODE_ND 0
#define ERR_CODE_FNF 1
#define ERR_CODE_AV 2
#define ERR_CODE_DF 3
#define ERR_CODE_IO 4
#define ERR_CODE_UTID 5
#define ERR_CODE_FAE 6
#define ERR_CODE_NSU 7

#define MODE_NETASCII "netascii"
#define MODE_OCTET "octet"
#define MODE_MAIL "mail"

#define MAX_REQ_SIZE OPCODE_LEN + FNAME_LEN + MODE_LEN 
#define MAX_DATA_SIZE OPCODE_LEN + DATA_LEN
#define MAX_ACK_SIZE OPCODE_LEN + BLOCK_LEN
#define MAX_ERR_SIZE OPCODE_LEN + ERRCODE_LEN + ERRMSG_LEN

#endif
