#ifndef __tftpproxy_h
#define __tftpproxy_h

#include <tftp.h>

#define max(a,b) (a<b? b: a)
#define min(a,b) (a<b? a: b)
#define __readn(fd, buff, n) recv(fd, buff, n, MSG_WAITALL)

#define PROXY_ADDR NULL
#define PROXY_PORT 1069
#define SERV_ADDR "127.0.0.1"
#define SERV_PORT IPPORT_TFTP
#define TIMEOUT_S 20
#define TIMEOUT_MS 0

#define MAX_PACKET_LEN 516

#define LOST_PRB 0
#define LOST_BURST_LEN 0
#define REPEAT_PRB 0
#define REPEAT_BURST_LEN 0

struct properties {
  char* s_addr;
  uint16_t s_port;
  char* p_addr;
  uint16_t p_port;
  long to_s;
  long to_us;
};

#ifdef _DEBUG
#include <stdio.h>
#define DBG_MSG(format, args...) printf(format, ## args)
#define DBG_LMSG(format, args...) \
DBG_MSG("%d: ",__LINE__); \
printf(format, ## args)
#define DBG_ERR(format, args...) \
perror(NULL); \
printf(format, ## args)
#else
#define DBG_MSG(format, args...)
#define DBG_LMSG(format, args...)
#define DBG_ERR(format, args...)
#endif

#endif
